"use strict";

var _interopRequire = function (obj) { return obj && obj.__esModule ? obj["default"] : obj; };

var callAction = _interopRequire(require("./callAction"));

var notFoundValue = _interopRequire(require("./notFoundValue"));

var ACTION_TYPE = require("./types").ACTION_TYPE;

module.exports = function (_ref) {
  var resources = _ref.resources;
  var states = _ref.states;
  return function (_ref2) {
    var actionSetID = _ref2.actionSetID;
    var actionID = _ref2.actionID;
    var payload = _ref2.payload;

    var changedStates = {};

    Object.keys(resources).forEach(function (resourceID) {
      var _resources$resourceID = resources[resourceID];
      var reducer = _resources$resourceID.reducer;
      var props = _resources$resourceID.props;

      var result = callAction({
        responder: reducer,
        type: ACTION_TYPE,
        initialState: states[resourceID],
        props: props,
        payload: payload,
        notFoundValue: notFoundValue,
        actionSetID: actionSetID,
        actionID: actionID
      });

      if (result !== notFoundValue) {
        changedStates[resourceID] = result;
      }
    });

    return changedStates;
  };
};