"use strict";

var _interopRequire = function (obj) { return obj && obj.__esModule ? obj["default"] : obj; };

var callAction = _interopRequire(require("./callAction"));

var INTROSPECTION_TYPE = require("./types").INTROSPECTION_TYPE;

var notFoundValue = _interopRequire(require("./notFoundValue"));

function consensusForReducerResults(allResults) {
  return {
    some: function some() {
      var callback = arguments[0] === undefined ? Boolean : arguments[0];

      return allResults.some(callback);
    },

    every: function every() {
      var callback = arguments[0] === undefined ? Boolean : arguments[0];

      return allResults.every(callback);
    },

    reduce: function reduce(callback, initialValue) {
      if (allResults.length === 0 && typeof initialValue === "undefined") {
        // Do not allow TypeError to be thrown.
        return;
      }

      return allResults.reduce(callback, initialValue);
    },

    toArray: function toArray() {
      return allResults;
    }
  };
}

module.exports = function (_ref) {
  var resources = _ref.resources;
  var states = _ref.states;
  return function (actionSetID) {
    return function (introspectionID) {
      return function (payload) {
        var allResults = Object.keys(resources).reduce(function (allResults, resourceID) {
          var _resources$resourceID = resources[resourceID];
          var reducer = _resources$resourceID.reducer;
          var props = _resources$resourceID.props;

          var currentValue = callAction({
            responder: reducer,
            type: INTROSPECTION_TYPE,
            initialState: states[resourceID],
            props: props,
            actionID: introspectionID,
            actionSetID: actionSetID,
            payload: payload,
            notFoundValue: notFoundValue
          });

          if (currentValue !== notFoundValue) {
            allResults.push(currentValue);
          }

          return allResults;
        }, []);

        return consensusForReducerResults(allResults);
      };
    };
  };
};